#ifndef _UTILS_H_
#define _UTILS_H_

#include <ddk.h>
#include <syscall.h>
#include <linux/string.h>
#include <linux/ctype.h>

static inline
unsigned char inb(unsigned short int port)
{
    unsigned char _v;
    __asm__ __volatile__ ("inb %w1,%0":"=a" (_v):"Nd" (port));
    return _v;
}

static inline
unsigned short int inw(unsigned short int port)
{
    unsigned short _v;
    __asm__ __volatile__ ("inw %w1,%0":"=a" (_v):"Nd" (port));
    return _v;
}

static inline
unsigned int inl(unsigned short int port)
{
    unsigned int _v;
    __asm__ __volatile__ ("inl %w1,%0":"=a" (_v):"Nd" (port));
    return _v;
}

static inline
void outb(unsigned char value, unsigned short int port)
{
    __asm__ __volatile__ ("outb %b0,%w1": :"a" (value), "Nd" (port));
}

static inline
void outw(unsigned short int value, unsigned short int port)
{
    __asm__ __volatile__ ("outw %w0,%w1": :"a" (value), "Nd" (port));
}

static inline
void outl(unsigned int value, unsigned short int port)
{
    __asm__ __volatile__ ("outl %0,%w1": :"a" (value), "Nd" (port));
}

char *strtok(char *s, const char *delim);
long strtol(const char *nptr, char **endptr, int base);
int atoi(const char *nptr);

#endif // _UTILS_H_
